de.esprit.common.gui

## Class ZFrame

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - java.awt.Window
      - - java.awt.Frame
        - - javax.swing.JFrame
          - - de.esprit.common.gui.ZFrame

- All Implemented Interfaces:
    BorderLayoutConstants, Closeable, ToolWindow, Dumpable, java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, javax.accessibility.Accessible, javax.swing.RootPaneContainer, javax.swing.WindowConstants
  Direct Known Subclasses:
    ApplicationMainFrame, ApplicationTestFrame, FatalErrorFrame, LogFrame, ToolFrame

      public abstract class ZFrame
      extends javax.swing.JFrame
      implements ToolWindow, BorderLayoutConstants

  This is the base class for all GUI Frames. It implements basic functionality which is actually missing in Swing. Note that this class also manages a current frame in the `Gui` class for attaching error dialogs.
  Author:
    Rainer Buesch
  See Also:
    `Gui.getMainFrame()`, `Gui.getCurrentWindow()`, Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class javax.swing.JFrame

      `javax.swing.JFrame.AccessibleJFrame`

    - ### Nested classes/interfaces inherited from class java.awt.Frame

      `java.awt.Frame.AccessibleAWTFrame`

    - ### Nested classes/interfaces inherited from class java.awt.Window

      `java.awt.Window.AccessibleAWTWindow, java.awt.Window.Type`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `java.awt.Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

  - ### Field Summary

    - ### Fields inherited from class javax.swing.JFrame

      `accessibleContext, EXIT_ON_CLOSE, rootPane, rootPaneCheckingEnabled`

    - ### Fields inherited from class java.awt.Frame

      `CROSSHAIR_CURSOR, DEFAULT_CURSOR, E_RESIZE_CURSOR, HAND_CURSOR, ICONIFIED, MAXIMIZED_BOTH, MAXIMIZED_HORIZ, MAXIMIZED_VERT, MOVE_CURSOR, N_RESIZE_CURSOR, NE_RESIZE_CURSOR, NORMAL, NW_RESIZE_CURSOR, S_RESIZE_CURSOR, SE_RESIZE_CURSOR, SW_RESIZE_CURSOR, TEXT_CURSOR, W_RESIZE_CURSOR, WAIT_CURSOR`

    - ### Fields inherited from class java.awt.Component

      `BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface de.esprit.common.gui.comp.BorderLayoutConstants

      `CENTER, EAST, NORTH, SOUTH, WEST`

    - ### Fields inherited from interface javax.swing.WindowConstants

      `DISPOSE_ON_CLOSE, DO_NOTHING_ON_CLOSE, HIDE_ON_CLOSE`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ZFrame()`
    `ZFrame(NlsKey nls)` Creates a frame with a translated title.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Makes the frame invisible.
    `protected void` | `closeByIcon()` Is called when closing the window by the close-icon
    `protected ToolWindowAdapter` | `createWindowAdapter()`
    `int` | `getMinimumHeight()`
    `int` | `getMinimumWidth()`
    `protected ToolWindowAdapter` | `getWindowAdapter()`
    `protected boolean` | `isErrorAttachable()` Defines whether an `ErrorDialog` may attach to this frame.
    `boolean` | `isLocated()`
    `boolean` | `isPacked()`
    `void` | `pack()` Overridden to store the isPacked state
    `void` | `popup()` Pops up the frame to become visible.
    `void` | `repack()` Runs a pack() as if it was the initial pack
    `void` | `setIcon(javax.swing.Icon icon)`
    `void` | `setIcon(IconKey iconKey)`
    `void` | `setLocation(int x, int y)`
    `void` | `setLocationRelativeTo(java.awt.Component c)`
    `void` | `setLocationRelativeTo(java.awt.Component comp, WindowAlignment alignment)`
    `void` | `setLocationToCenter()` Positions the frame in the center of the screen.
    `void` | `setTitle(NlsKey nls, java.lang.Object... args)` Overridden to use a translated frame title
    `void` | `setVisible(boolean isVisible)` Overridden to ensure that the dialog is being packed before it becomes visible
    `void` | `shiftLocation(int deltaX, int deltaY)` Moves the frame on the screen by the given amount.
    `java.lang.String` | `toDumpString()` Returns a multi-line String that shows the values (name=value) of all important state variables of this object.
    `DumpString` | `toDumpString(DumpString s)` This method allows subclasses to add values to the existing DumpString of the superclass.
    `java.lang.String` | `toString()` Returns a single line String that shows the values of the most important state variables of this object.
    `ToString` | `toString(ToString s)` This method allows subclasses to add values to the existing ToString of the superclass.

    - ### Methods inherited from class javax.swing.JFrame

      `addImpl, createRootPane, frameInit, getAccessibleContext, getContentPane, getDefaultCloseOperation, getGlassPane, getGraphics, getJMenuBar, getLayeredPane, getRootPane, getTransferHandler, isDefaultLookAndFeelDecorated, isRootPaneCheckingEnabled, paramString, processWindowEvent, remove, repaint, setContentPane, setDefaultCloseOperation, setDefaultLookAndFeelDecorated, setGlassPane, setIconImage, setJMenuBar, setLayeredPane, setLayout, setRootPane, setRootPaneCheckingEnabled, setTransferHandler, update`

    - ### Methods inherited from class java.awt.Frame

      `addNotify, getCursorType, getExtendedState, getFrames, getIconImage, getMaximizedBounds, getMenuBar, getState, getTitle, isResizable, isUndecorated, remove, removeNotify, setBackground, setCursor, setExtendedState, setMaximizedBounds, setMenuBar, setOpacity, setResizable, setShape, setState, setTitle, setUndecorated`

    - ### Methods inherited from class java.awt.Window

      `addPropertyChangeListener, addPropertyChangeListener, addWindowFocusListener, addWindowListener, addWindowStateListener, applyResourceBundle, applyResourceBundle, createBufferStrategy, createBufferStrategy, dispose, getBackground, getBufferStrategy, getFocusableWindowState, getFocusCycleRootAncestor, getFocusOwner, getFocusTraversalKeys, getIconImages, getInputContext, getListeners, getLocale, getModalExclusionType, getMostRecentFocusOwner, getOpacity, getOwnedWindows, getOwner, getOwnerlessWindows, getShape, getToolkit, getType, getWarningString, getWindowFocusListeners, getWindowListeners, getWindows, getWindowStateListeners, hide, isActive, isAlwaysOnTop, isAlwaysOnTopSupported, isAutoRequestFocus, isFocusableWindow, isFocusCycleRoot, isFocused, isLocationByPlatform, isOpaque, isShowing, isValidateRoot, paint, postEvent, processEvent, processWindowFocusEvent, processWindowStateEvent, removeWindowFocusListener, removeWindowListener, removeWindowStateListener, reshape, setAlwaysOnTop, setAutoRequestFocus, setBounds, setBounds, setCursor, setFocusableWindowState, setFocusCycleRoot, setIconImages, setLocation, setLocationByPlatform, setMinimumSize, setModalExclusionType, setSize, setSize, setType, show, toBack, toFront`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getAlignmentX, getAlignmentY, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalPolicy, getInsets, getLayout, getMaximumSize, getMinimumSize, getMousePosition, getPreferredSize, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, print, printComponents, processContainerEvent, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusTraversalKeys, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setFont, transferFocusDownCycle, validate, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, disable, disableEvents, dispatchEvent, enable, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBaseline, getBaselineResizeBehavior, getBounds, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphicsConfiguration, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocation, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, prepareImage, prepareImage, printAll, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, processMouseWheelEvent, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resize, resize, revalidate, setComponentOrientation, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeysEnabled, setForeground, setIgnoreRepaint, setLocale, setMaximumSize, setName, setPreferredSize, show, size, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface de.esprit.common.gui.ToolWindow

      `getLocation, getSize, getTitle, getToolkit, setMinimumSize, setPreferredSize`

    - ### Methods inherited from interface java.awt.MenuContainer

      `getFont, postEvent`

- - ### Constructor Detail

    - #### ZFrame

          public ZFrame()

    - #### ZFrame

          public ZFrame(NlsKey nls)

      Creates a frame with a translated title.

  - ### Method Detail

    - #### getWindowAdapter

          protected ToolWindowAdapter getWindowAdapter()

    - #### createWindowAdapter

          protected ToolWindowAdapter createWindowAdapter()

    - #### setLocation

          public final void setLocation(int x,
                         int y)

      Specified by:
        `setLocation` in interface `ToolWindow`
      Overrides:
        `setLocation` in class `java.awt.Window`

    - #### isLocated

          public final boolean isLocated()

    - #### pack

          public void pack()

      Overridden to store the isPacked state
      Specified by:
        `pack` in interface `ToolWindow`
      Overrides:
        `pack` in class `java.awt.Window`

    - #### repack

          public final void repack()

      Runs a pack() as if it was the initial pack

    - #### isPacked

          public final boolean isPacked()

      Specified by:
        `isPacked` in interface `ToolWindow`

    - #### getMinimumHeight

          public int getMinimumHeight()

      Specified by:
        `getMinimumHeight` in interface `ToolWindow`

    - #### getMinimumWidth

          public int getMinimumWidth()

      Specified by:
        `getMinimumWidth` in interface `ToolWindow`

    - #### setIcon

          public final void setIcon(IconKey iconKey)

    - #### closeByIcon

          protected void closeByIcon()

      Is called when closing the window by the close-icon

    - #### setIcon

          public final void setIcon(javax.swing.Icon icon)

    - #### popup

          public void popup()

      Pops up the frame to become visible.
      Specified by:
        `popup` in interface `ToolWindow`

    - #### close

          public void close()

      Makes the frame invisible.
      Specified by:
        `close` in interface `Closeable`

    - #### setVisible

          public final void setVisible(boolean isVisible)

      Overridden to ensure that the dialog is being packed before it becomes visible
      Overrides:
        `setVisible` in class `java.awt.Window`

    - #### setLocationRelativeTo

          public final void setLocationRelativeTo(java.awt.Component c)

      Specified by:
        `setLocationRelativeTo` in interface `ToolWindow`
      Overrides:
        `setLocationRelativeTo` in class `java.awt.Window`

    - #### setTitle

          public final void setTitle(NlsKey nls,
                      java.lang.Object... args)

      Overridden to use a translated frame title

    - #### isErrorAttachable

          protected boolean isErrorAttachable()

      Defines whether an `ErrorDialog` may attach to this frame. Message dialogs (like Error dialogs) must not change the Gui's current dialog because they are not hooks for attaching other dialogs.

    - #### setLocationToCenter

          public final void setLocationToCenter()

      Positions the frame in the center of the screen. Note: This method only works after a call of pack().

    - #### shiftLocation

          public final void shiftLocation(int deltaX,
                           int deltaY)

      Moves the frame on the screen by the given amount. Borders are checked - so the frame will not move out of the screen area.
      Specified by:
        `shiftLocation` in interface `ToolWindow`

    - #### setLocationRelativeTo

          public final void setLocationRelativeTo(java.awt.Component comp,
                                   WindowAlignment alignment)

    - #### toDumpString

          public java.lang.String toDumpString()

      Description copied from interface: `Dumpable`
      Returns a multi-line String that shows the values (name=value) of all important state variables of this object.
      Specified by:
        `toDumpString` in interface `Dumpable`

    - #### toString

          public java.lang.String toString()

      Description copied from interface: `Dumpable`
      Returns a single line String that shows the values of the most important state variables of this object. This is intentionally the same toString() method which is already provided by Object per se.
      Specified by:
        `toString` in interface `Dumpable`
      Overrides:
        `toString` in class `java.awt.Component`

    - #### toString

          public ToString toString(ToString s)

      Description copied from interface: `Dumpable`
      This method allows subclasses to add values to the existing ToString of the superclass. Usually subclasses only need to override this method.
      Specified by:
        `toString` in interface `Dumpable`

    - #### toDumpString

          public DumpString toDumpString(DumpString s)

      Description copied from interface: `Dumpable`
      This method allows subclasses to add values to the existing DumpString of the superclass. Usually subclasses only need to override this method.
      Specified by:
        `toDumpString` in interface `Dumpable`

Copyright © 2014 EsprIT-Systems. All Rights Reserved.